## dde-network-core 2.0.34

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION "2.0.18" CACHE STRING "define project version")
project(dde-network-core
  VERSION ${VERSION}
  DESCRIPTION "DDE Network Core"
  HOMEPAGE_URL "https://github.com/linuxdeepin/dde-network-core"
  LANGUAGES CXX C
)

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -z relro -z now -z noexecstack -pie")

option(ENABLE_DEEPIN_NMQT "enable nmqt patch on deepin" OFF)

set(DDE-Network-Core_INCLUDE_DIRS  "${CMAKE_SOURCE_DIR}/src")
set(DDE-Network-Core_LIBRARIES  dde-network-core)

find_package(PkgConfig REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)
include_directories(${LibNM_INCLUDE_DIRS})

pkg_check_modules(Gio REQUIRED gio-2.0)
include_directories(${Gio_INCLUDE_DIRS})

pkg_search_module(GLIB REQUIRED glib-2.0)
include_directories(${GLIB_INCLUDE_DIRS})
link_directories(${GLIB_LIBRARY_DIRS})

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

if (QT_DEBUG)
    message(" KF5_QT_INCLUDE_DIRS : " ${KF5_QT_INCLUDE_DIRS})
    message(" GLIB_INCLUDE_DIRS :" ${GLIB_INCLUDE_DIRS})
    message(" CMAKE_CURRENT_SOURCE_DIR: " ${CMAKE_CURRENT_SOURCE_DIR})
    message(STATUS ${result})
endif()

if (ENABLE_DEEPIN_NMQT)
    add_definitions(-DUSE_DEEPIN_NMQT)
endif()

message(STATUS DEEPIN_NMQT_TEST ": ${DEEPIN_NMQT_TEST}")

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/usr")
endif()
include(GNUInstallDirs)

add_subdirectory("src")
add_subdirectory("dcc-network-plugin")
add_subdirectory("tests")
add_subdirectory("example")
#add_subdirectory("dock-network-plugin")
add_subdirectory("dss-network-plugin")
add_subdirectory("dss_example")
#add_subdirectory("dock-example")

=== dcc-network-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dcc-network-plugin")

project(${PLUGIN_NAME})

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
ADD_DEFINITIONS("-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

# 指定所有源码文件
file(GLOB_RECURSE SRCS "*.h"
    "*.cpp"
    "../src/*.h"
    "../src/*.cpp"
    "*.qrc"
    "*.svg"
)

# 指定要用到的库
find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(DdeControlCenter REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
#pkg_check_modules(DDE-Network-Core REQUIRED dde-network-core)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

file(GLOB TS_FILES "translations/*.ts")

qt5_add_translation(QM_FILES ${TS_FILES})

add_custom_target(translations ALL DEPENDS ${QM_FILES})

# 新增一个编译目标
# 这里使用命令 add_library 来表示本项目要生成一个库文件目标，
add_library(${PLUGIN_NAME} SHARED ${SRCS})

# 设置目标要使用的 include 目录，即头文件目录
# 变量 ${DtkWidget_INCLUDE_DIRS} 是在前面执行 find_package 命令时引入的
# 当出现编译失败提示找不到某些库的头文件时应该检查此处是否将所有需要的头文件都包含了
target_include_directories(${PLUGIN_NAME} PUBLIC
    window
    operation
    ${KF5_QT_INCLUDE_DIRS}
    ${NETINTERFACEINCLUDE}
    ${DDE-Network-Core_INCLUDE_DIRS}
)
# 设置目标要使用的链接库
# 变量 ${DtkWidget_LIBRARIES} 和 ${Qt5Widgets_LIBRARIES} 是在前面执行 find_package 命令时引入的
# 当出现运行时错误提示某些符号没有定义时应该检查此处是否将所有用的库都写在了这里
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${KF5_QT_LIBRARIES}
    Dtk::Widget
    Qt5::Widgets
    Qt5::Network
    Qt5::DBus
    Dde::DCCWidget
    Dde::DCCInterface
    ${DDE-Network-Core_LIBRARIES}
)

# 设置执行 make install 时哪个目标应该被 install 到哪个位置
install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-control-center/modules)

# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dde-control-center/translations)

=== dock-network-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dock-network-plugin")

project(${PLUGIN_NAME})
# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE SRCS "*.h" "*.cpp" "item/*.h" "item/*.cpp" "../common-plugin/*.h" "../common-plugin/*.cpp")

find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(DtkCore REQUIRED)
find_package(DtkWidget REQUIRED)

set(DTKCORE_INCLUDE_DIR DTKCORE_INCLUDE_DIRS)

find_package(DdeDock REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(DDE-Dock REQUIRED dde-dock)

file(GLOB TS_FILES "translations/*.ts")
qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(language ALL DEPENDS ${QM_FILES})

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} ../common-plugin/network.qrc)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

target_include_directories(${PLUGIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${DDE-Network-Core_INCLUDE_DIRS}
    ${DDE_DOCK_INCLUDE_DIR}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    ${NETINTERFACEINCLUDE}
    "../common-plugin/"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${DDE-Network-Core_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${Qt5Network_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/quick-trays)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)

=== dss-network-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dss-network-plugin")

project(${PLUGIN_NAME})

# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE SRCS "*.h" "*.cpp"  "../common-plugin/*.h" "../common-plugin/*.cpp")

find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
find_package(DdeSessionShell REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)

file(GLOB TS_FILES "translations/*.ts")
qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(${TARGET_NAME}_language ALL DEPENDS ${QM_FILES})

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} ../common-plugin/network.qrc)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

target_include_directories(${PLUGIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${DDE-Network-Core_INCLUDE_DIRS}
    ${DDESESSIONSHELL_INCLUDE_DIR}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    ${NETINTERFACEINCLUDE}
    "../common-plugin/"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${DDE-Network-Core_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${Qt5Network_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)

install(FILES 50-dss-network-plugin.rules DESTINATION share/polkit-1/rules.d)

=== debian/changelog ===
dde-network-core (2.0.34) unstable; urgency=medium

  * fix: Save button is not enabled when proxy address changed after saving

 -- Yutao Meng <mengyutao@deepin.org>  Wed, 11 Sep 2024 16:02:53 +0800

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

export QT_SELECT = qt5

DISTRO = $(shell lsb_release -is)
ifeq ($(DISTRO),Deepin)
	ENABLE_DEEPIN_NMQT=ON
else
	ENABLE_DEEPIN_NMQT=OFF
endif

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
%:
	dh $@ --parallel
override_dh_auto_configure:
	dh_auto_configure -- -DVERSION=$(PACK_VER) -DENABLE_DEEPIN_NMQT=${ENABLE_DEEPIN_NMQT}

## dde-network-core 2.0.54

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,11 +15,10 @@
 
 option(ENABLE_DEEPIN_NMQT "enable nmqt patch on deepin" OFF)
 
-set(DDE-Network-Core_INCLUDE_DIRS  "${CMAKE_SOURCE_DIR}/src")
+set(DDE-Network-Core_INCLUDE_DIRS  "${CMAKE_SOURCE_DIR}/src-old")
 set(DDE-Network-Core_LIBRARIES  dde-network-core)
 
 find_package(PkgConfig REQUIRED)
-find_package(KF5NetworkManagerQt REQUIRED)
 pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)
 include_directories(${LibNM_INCLUDE_DIRS})
 
@@ -29,19 +28,6 @@
 pkg_search_module(GLIB REQUIRED glib-2.0)
 include_directories(${GLIB_INCLUDE_DIRS})
 link_directories(${GLIB_LIBRARY_DIRS})
-
-set(TRY_KF5_LIBRARIES
-IMPORTED_LOCATION_DEBIAN
-IMPORTED_LOCATION_NOCONFIG
-)
-
-if (NOT KF5_QT_LIBRARIES)
-    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
-endif()
-
-find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
-find_package(KF5NetworkManagerQt REQUIRED)
-get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
 
 if (QT_DEBUG)
     message(" KF5_QT_INCLUDE_DIRS : " ${KF5_QT_INCLUDE_DIRS})
@@ -56,16 +42,22 @@
 
 message(STATUS DEEPIN_NMQT_TEST ": ${DEEPIN_NMQT_TEST}")
 
+set(INTERFACE_VERSION "2.0")
+add_definitions(-DINTERFACE_VERSION="${INTERFACE_VERSION}")
+message("Interface Version: " ${INTERFACE_VERSION})
 if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
     set(CMAKE_INSTALL_PREFIX "/usr")
 endif()
 include(GNUInstallDirs)
 
 add_subdirectory("src")
-add_subdirectory("dcc-network-plugin")
+# add_subdirectory("src-old")
+# add_subdirectory("dcc-network-plugin")
+add_subdirectory("dcc-network")
 add_subdirectory("tests")
-add_subdirectory("example")
-#add_subdirectory("dock-network-plugin")
+# add_subdirectory("example")
+add_subdirectory("dock-network-plugin")
 add_subdirectory("dss-network-plugin")
-add_subdirectory("dss_example")
+# add_subdirectory("dss_example")
 #add_subdirectory("dock-example")
+add_subdirectory("network-service-plugin")

=== dcc-network/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dcc-network-plugin")

project(${PLUGIN_NAME})

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
ADD_DEFINITIONS("-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

# 指定所有源码文件
# file(GLOB_RECURSE SRCS "*.h"
#     "*.cpp"
# )

# 指定要用到的库
# -DQT_MAJOR_VERSION=6
# find_package(QT NAMES Qt6 Qt5)
# set(QT_MAJOR_VERSION 6)
# set(QT_DEFAULT_MAJOR_VERSION 6)
# find_package(Qt6 REQUIRED COMPONENTS Quick)
find_package(Qt6 COMPONENTS Core Gui DBus Network LinguistTools REQUIRED)
find_package(DdeControlCenter REQUIRED)
find_package(Dtk6 COMPONENTS Core REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(KF6NetworkManagerQt REQUIRED)
#pkg_check_modules(DDE-Network-Core REQUIRED dde-network-core)


set(DccNetwork_Name network)
file(GLOB_RECURSE DccNetwork_SRCS
        "*.cpp"
        "*.h"
        "../net-view/operation/*.cpp"
        "../net-view/operation/*.h"
        "../net-view/window/qrc/network.qrc"
        # "qrc/systeminfo.qrc"
)

add_library(${DccNetwork_Name} MODULE
        ${DccNetwork_SRCS}
)

target_include_directories(${DccNetwork_Name} PUBLIC
    Dde::Control-Center
    "../net-view/operation"
    "../src"
)

set(DccNetwork_Libraries
        Qt6::DBus
        Qt6::Network
        Qt6::Gui
        # Qt6::Quick
        Dtk6::Core
        KF6::NetworkManagerQt
        Dde::Control-Center
        dde-network-core6
)

target_link_libraries(${DccNetwork_Name} PRIVATE
        ${DccNetwork_Libraries}
)

dcc_install_plugin(NAME ${DccNetwork_Name} TARGET ${DccNetwork_Name})

dcc_handle_plugin_translation(NAME ${DccNetwork_Name} )

=== dss-network-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dss-network-plugin")

project(${PLUGIN_NAME})

include(GNUInstallDirs)
# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)
set(NET_USE_NOTIFICATION ON)

file(GLOB_RECURSE SRCS "networkmodule.h" "networkmodule.cpp"  "../net-view/*.h" "../net-view/*.cpp")

find_package(Qt6 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
# find_package(Qt5Svg REQUIRED)
find_package(Dtk6 COMPONENTS Widget REQUIRED)
find_package(KF6NetworkManagerQt REQUIRED)
find_package(DdeSessionShell REQUIRED)

# if (CMAKE_BUILD_TYPE STREQUAL "Debug")
#     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O0")
#     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O0")
# endif()

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")

if (NET_USE_NOTIFICATION)
    add_definitions(-DNET_USE_NOTIFICATION)
    file(GLOB_RECURSE NOTIFICATION_SRCS "notification/*.h" "notification/*.cpp")
    set(SRCS ${SRCS} ${NOTIFICATION_SRCS})
endif()

file(GLOB TS_FILES "translations/*.ts")
qt_add_translations(${TARGET_NAME}_language
    TS_FILES ${TS_FILES}
    SOURCES ${SRCS}
    LUPDATE_OPTIONS -no-obsolete -no-ui-lines -locations none
    QM_FILES_OUTPUT_VARIABLE QM_FILES
)

add_custom_target(${TARGET_NAME}_language ALL DEPENDS ${QM_FILES})
add_library(${PLUGIN_NAME} SHARED ${SRCS} ../net-view/window/qrc/network.qrc)

target_include_directories(${PLUGIN_NAME} PUBLIC
    Dtk6::Widget
    Qt6::DBus
    Qt6::Network
    Qt6::Widgets
    ${DDESESSIONSHELL_INCLUDE_DIR}
    KF6::NetworkManagerQt
    "../net-view/operation"
    "../net-view/window"
    "../src"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    Dtk6::Widget
    Qt6::DBus
    Qt6::Network
    Qt6::Widgets
    dde-network-core6
    KF6::NetworkManagerQt
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)

install(FILES 10-network-manager.pkla DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/polkit-1/localauthority/10-vendor.d)

=== network-service-plugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.13)

set(BIN_NAME "network-service")

project(${BIN_NAME})

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

include(GNUInstallDirs)
file(GLOB_RECURSE SRCS "*.h" "*.cpp")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    ADD_DEFINITIONS(-DQM_FILES_DIR="${CMAKE_BINARY_DIR}/network-service-plugin")
else()
    ADD_DEFINITIONS(-DQM_FILES_DIR="/usr/share/deepin-service-manager/network-service/translations")
endif()
set(QT_NS 6)
set(DTK_NS Dtk6)
find_package(Qt${QT_NS} COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(KF${QT_NS}NetworkManagerQt REQUIRED)
find_package(${DTK_NS} COMPONENTS Core REQUIRED)

file(GLOB TS_FILES "translations/*.ts")
qt_add_translation(QM_FILES ${TS_FILES})
add_custom_target(${BIN_NAME}_language ALL DEPENDS ${QM_FILES})

pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)

add_library(${BIN_NAME} MODULE
    ${SRCS}
)

target_include_directories(${BIN_NAME} PUBLIC
  Qt${QT_NS}::Core
  Qt${QT_NS}::DBus
  Qt${QT_NS}::Network
  KF${QT_NS}::NetworkManagerQt
  ${DTK_NS}::Core
  .
  system
  session
  utils
  accountnetwork/system
  accountnetwork/system/accountnetwork
  accountnetwork/session/
  accountnetwork/session/accountnetwork
)

target_link_libraries(${BIN_NAME} PRIVATE
  Qt${QT_NS}::Core
  Qt${QT_NS}::DBus
  Qt${QT_NS}::Network
  KF${QT_NS}::NetworkManagerQt
  ${DTK_NS}::Core
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/system/)
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/user/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/system/plugin-system-network.json ${CMAKE_BINARY_DIR}/share/system/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/session/plugin-session-network.json ${CMAKE_BINARY_DIR}/share/user/)
else()
    # just need this in your project
    install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/system/plugin-system-network.json DESTINATION share/deepin-service-manager/system/)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/session/plugin-session-network.json DESTINATION share/deepin-service-manager/user/)
endif()

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/system/org.deepin.service.SystemNetwork.conf DESTINATION share/dbus-1/system.d/)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/session/org.deepin.service.SessionNetwork.conf DESTINATION share/dbus-1/system.d/)
# 安装.qm文件
install(FILES ${QM_FILES} DESTINATION share/deepin-service-manager/network-service/translations/)

=== debian/changelog ===
dde-network-core (2.0.54) unstable; urgency=medium

  * fix: Synchronize dss-network-plugin 107x interface
  * fix: DSL should not be displayed without wired network devices
  * fix: Airplane mode not monitoring Bluetooth status
  * fix: Do not enable hotspots when modifying hotspot configurations
  * fix: import QtQml.Models
  * fix: Personal hotspot status when modifying airplane mode

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 17 Apr 2025 16:22:20 +0800

dde-network-core (2.0.53) unstable; urgency=medium

  * fix: Update translation
  * feat: Synchronize to 107x

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 10 Apr 2025 16:32:20 +0800

dde-network-core (2.0.52) unstable; urgency=medium

  * fix: Remove Qt5 dependencies

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 27 Mar 2025 15:52:20 +0800

dde-network-core (2.0.51) unstable; urgency=medium

  * fix: Modify network service crash issue

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 20 Mar 2025 17:42:20 +0800

dde-network-core (2.0.50) unstable; urgency=medium

  * fix: Record the last proxy method
  * fix: Modifying network connection issue without automatic creation

 -- caixiangrong <caixiangrong@uniontech.com>  Fri, 14 Mar 2025 10:02:20 +0800

dde-network-core (2.0.49) unstable; urgency=medium

  * fix: Modify the proxy switch associated variable

 -- caixiangrong <caixiangrong@uniontech.com>  Wed, 12 Mar 2025 10:46:20 +0800

dde-network-core (2.0.48) unstable; urgency=medium

  * fix: Update translation
  * fix: Upgrade Qt version
  * feat: Add files generated by qdbusXML2cpp and DCONG2cpp

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 6 Mar 2025 16:46:20 +0800

dde-network-core (2.0.47) unstable; urgency=medium

  * fit: Modify searchable items

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 27 Feb 2025 16:56:20 +0800

dde-network-core (2.0.46) unstable; urgency=medium

  * fix: Pop up authentication dialog box

 -- Robertkill <lvpeilong@uniontech.com>  Tue, 11 Feb 2025 13:56:20 +0800

dde-network-core (2.0.45) unstable; urgency=medium

  * 2.0.44

 -- YeShanShan <yeshanshan@uniontech.com>  Fri, 24 Jan 2025 10:55:51 +0800

dde-network-core (2.0.44) unstable; urgency=medium

  * fix: network did not automatically create

 -- caixiangrong <caixiangrong@uniontech.com>  Fri, 17 Dec 2025 09:22:47 +0800

dde-network-core (2.0.43) unstable; urgency=medium

  * fix: Modify hotspot UI style
  * fix: Update network icon

 -- caixiangrong <caixiangrong@uniontech.com>  Mon, 13 Dec 2025 09:22:47 +0800

dde-network-core (2.0.42) unstable; urgency=medium

  * fix: Password configuration should not be saved without a password
  * fix: IPv6 regular expression error
  * fix: Add deepin-service-plugin-network
  * fix: Create a temporary connection to an unconnected wireless network
  * fix: The data of the network proxy is not saved correctly

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 02 Jan 2025 13:46:12 +0800

dde-network-core (2.0.41) unstable; urgency=medium

  * fix: Change the network configuration interface to 107x style
  * fix: Modify hotspot configuration error
  * fix: Wireless enterprise network did not obtain password correctly

 -- caixiangrong <caixiangrong@uniontech.com>  Wed, 25 Dec 2024 16:22:47 +0800

dde-network-core (2.0.40) unstable; urgency=medium

  * feat: Update weight
  * fix: Add network parameter jump function
  * fix: Modify the SSID location on the wireless network configuration page
  * fix: Failed to modify VPN import issue

 -- caixiangrong <caixiangrong@uniontech.com>  Fri, 13 Dec 2024 16:22:47 +0800

dde-network-core (2.0.39) unstable; urgency=medium

  * fix: Implement entering the dde-control-center network configuration page from the dock
  * feat: Update translation
  * feat: Add menu item description
  * fix: Enterprise network cannot connect
  * fix: Modifying VPN configuration file without naming issue
  * fix: Processing password unedited and not visible
  * feat: Update weight

 -- caixiangrong <caixiangrong@uniontech.com>  Sat, 07 Dec 2024 16:02:47 +0800

dde-network-core (2.0.38) unstable; urgency=medium

  * fix: Standardize IconLabel writing

 -- caixiangrong <caixiangrong@uniontech.com>  Mon, 25 Nov 2024 14:08:47 +0800

dde-network-core (2.0.37) unstable; urgency=medium

  * fix: Adaptation control center interface adjustment
  * fix: Handling hidden logic on web pages

 -- caixiangrong <caixiangrong@uniontech.com>  Fri, 22 Nov 2024 17:38:47 +0800

dde-network-core (2.0.36) unstable; urgency=medium

  * release 2.0.36

 -- Mike Chen <chenke@deepin.org>  Thu, 31 Oct 2024 13:38:47 +0800

dde-network-core (2.0.35) unstable; urgency=medium

  * fix: Crash after manual proxy is saved
  * feat: Implement control center network plugin

 -- caixiangrong <caixiangrong@uniontech.com>  Tue, 06 Aug 2024 15:45:40 +0800

## dde-network-core 2.0.57.1

=== dock-network-plugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

set(PLUGIN_NAME "dock-network-plugin")

set(QT_NS Qt6)
set(DTK_NS Dtk6)

project(${PLUGIN_NAME})
include(GNUInstallDirs)
# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE SRCS
    "networkplugin.h"
    "networkplugin.cpp"
    "quickpanelwidget.h"
    "quickpanelwidget.cpp"
    "dockcontentwidget.h"
    "../net-view/*.h"
    "../net-view/*.cpp"
    "widget/jumpsettingbutton.h"
    "widget/jumpsettingbutton.cpp"
    "widget/commoniconbutton.h"
    "widget/commoniconbutton.cpp"
)

find_package(${QT_NS} COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(${DTK_NS} REQUIRED COMPONENTS Widget)
find_package(KF6NetworkManagerQt REQUIRED)
find_package(DdeDock REQUIRED)

#if (CMAKE_BUILD_TYPE STREQUAL "Debug")
#    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O0")
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O0")
#endif()

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} ../net-view/window/qrc/network.qrc)
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../../dde-dock)

file(GLOB TS_FILES "translations/*.ts")
qt_add_translations(${PLUGIN_NAME}_language
    TS_FILES ${TS_FILES}
    SOURCES ${SRCS}
    LUPDATE_OPTIONS -no-obsolete -no-ui-lines -locations none
    QM_FILES_OUTPUT_VARIABLE QM_FILES
)
add_custom_target(${PLUGIN_NAME}_language ALL DEPENDS ${QM_FILES})
# get_target_property(KF6_QT_INCLUDE_DIRS KF6::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

target_include_directories(${PLUGIN_NAME} PUBLIC
    ${DTK_NS}::Widget
    ${QT_NS}::Dbus
    ${QT_NS}::Network
    KF6::NetworkManagerQt
    # "../../../interfaces"
    "../net-view/operation"
    "../net-view/window"
    "../src"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${QT_NS}::Widgets
    ${QT_NS}::DBus
    ${QT_NS}::Network
    ${DTK_NS}::Widget
    KF6::NetworkManagerQt
    dde-network-core6
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/system-trays)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)
# 安装显示在控制中心-个性化-任务栏-插件区域的图标
install(FILES "resources/dcc-network.dci" DESTINATION share/dde-dock/icons/dcc-setting)

=== dss-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -69,4 +69,4 @@
 # 安装 .qm 文件
 install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)
 
-install(FILES 10-network-manager.pkla DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/polkit-1/localauthority/10-vendor.d)
+install(FILES 50-dss-network-plugin.rules DESTINATION ${CMAKE_INSTALL_DATADIR}/polkit-1/rules.d)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION "3.0.0" CACHE STRING "define project version")
project(dde-network-core6)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

include(GNUInstallDirs)

file(GLOB_RECURSE SOURCEFILES "*.h" "*.cpp")




add_library(${PROJECT_NAME} SHARED ${SOURCEFILES})

find_package(Qt6 COMPONENTS Core DBus Network Gui LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Dtk6 COMPONENTS Core REQUIRED)
find_package(KF6NetworkManagerQt REQUIRED)

pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)

file(GLOB TS_FILES "translations/*.ts")

qt_add_translation(QM_FILES ${TS_FILES})
add_custom_target(networktranslations ALL DEPENDS ${QM_FILES})

target_include_directories(${PROJECT_NAME} PUBLIC
    dbus
    impl
    impl/networkmanager
    impl/serviceinter
    Qt6::Core
    Qt6::DBus
    Qt6::Network
    Qt6::Gui
    Dtk6::Core
    KF6::NetworkManagerQt
    PkgConfig::LibNM
)

message(STATUS ${LibNM_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME} PRIVATE
    Qt6::Core
    Qt6::DBus
    Qt6::Network
    Qt6::Gui
    Dtk6::Core
    KF6::NetworkManagerQt
    PkgConfig::LibNM
    udev
)

configure_file(dde-network-core.pc.in ../dde-network-core.pc @ONLY)

set(INTERFACEFILES
    impl/dslcontroller.h
    impl/hotspotcontroller.h
    impl/vpncontroller.h
    networkconst.h
    networkcontroller.h
    networkdetails.h
    networkdevicebase.h
    proxycontroller.h
    wireddevice.h
    wirelessdevice.h)

set_target_properties(${PROJECT_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    # OUTPUT_NAME dde-network-core
    # EXPORT_NAME Network-Core
)

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${CMAKE_BINARY_DIR}/dde-network-core.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(FILES ${INTERFACEFILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libddenetworkcore)
install(FILES ../config/org.deepin.dde.network.json DESTINATION ${CMAKE_INSTALL_DATADIR}/dsg/configs/org.deepin.dde.network)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/dde-network-core/translations)

=== debian/changelog ===
dde-network-core (2.0.57.1) unstable; urgency=medium

  * fix: add transifex config
  * fix: Block application proxy menu
  * fix: Abnormal issue with modifying network icons

 -- caixiangrong <caixiangrong@uniontech.com>  Tue, 13 May 2025 16:50:40 +0800

dde-network-core (2.0.56) unstable; urgency=medium

  * fix: Add VPN configuration parameter check
  * fix: Add flags of wifi6
  * fix: Modify can't connect to new WiFi issues

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 08 May 2025 16:43:39 +0800

dde-network-core (2.0.55) unstable; urgency=medium

  * fix: Modify icon color processing
  * fix: Modifying network configuration displays errors
  * fix: Modifying the opening and closing of VPN caused a crash issue

 -- YeShanShan <yeshanshan@uniontech.com>  Tue, 29 Apr 2025 13:11:37 +0800

## dde-network-core 2.0.60

=== CMakeLists.txt ===
--- 
+++ 
@@ -54,7 +54,9 @@
 # add_subdirectory("src-old")
 # add_subdirectory("dcc-network-plugin")
 add_subdirectory("dcc-network")
-add_subdirectory("tests")
+if (CMAKE_BUILD_TYPE STREQUAL "Debug")
+    add_subdirectory("tests")
+endif()
 # add_subdirectory("example")
 add_subdirectory("dock-network-plugin")
 add_subdirectory("dss-network-plugin")

=== debian/changelog ===
dde-network-core (2.0.60) unstable; urgency=medium

  * chore: remove reginal variants for es language
  * i18n: Translate network_en_US.ts in es (#360)
  * i18n: Updates for project Deepin Desktop Environment (#359)
  * i18n: Updates for project Deepin Desktop Environment (#353)
  * chore: Modify compilation issues

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 12 Jun 2025 16:20:40 +0800

dde-network-core (2.0.59) unstable; urgency=medium

  * feat(network): add full IPv6 DNS support and fix persistence issues
  * i18n: Translate network_en_US.ts in sq (#352)
  * fix: translation not loaded if language code not fully matched
  * i18n: Updates for project Deepin Desktop Environment (#350)
  * i18n: Updates for project Deepin Desktop Environment (#348)
  * fix: source string for dcc-network resource is empty

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 12 Jun 2025 16:20:40 +0800

dde-network-core (2.0.58) unstable; urgency=medium

  * i18n: Translate
  * fix: when hide plugin,setting button sholud be hided

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 29 May 2025 15:20:40 +0800

dde-network-core (2.0.57) unstable; urgency=medium

  * fix: add transifex config
  * fix: Block application proxy menu
  * fix: Abnormal issue with modifying network icons

 -- caixiangrong <caixiangrong@uniontech.com>  Tue, 13 May 2025 16:50:40 +0800

## dde-network-core 2.0.63

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,11 +7,6 @@
   HOMEPAGE_URL "https://github.com/linuxdeepin/dde-network-core"
   LANGUAGES CXX C
 )
-
-# 增加安全编译参数
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
-set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -z relro -z now -z noexecstack -pie")
 
 option(ENABLE_DEEPIN_NMQT "enable nmqt patch on deepin" OFF)

=== dcc-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -16,8 +16,8 @@
 # 指定所有源码文件
 file(GLOB_RECURSE SRCS "*.h"
     "*.cpp"
-    "../src/*.h"
-    "../src/*.cpp"
+    "../src-old/*.h"
+    "../src-old/*.cpp"
     "*.qrc"
     "*.svg"
 )

=== dock-hotspot-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dock-hotspot-plugin")

project(${PLUGIN_NAME})
include(GNUInstallDirs)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE SRCS "*.h" "*.cpp" "../common-plugin/widgets/*" "../common-plugin/plugin_global.g")

find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(DtkCore REQUIRED)
find_package(DtkWidget REQUIRED)

find_package(DdeDock REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)

pkg_check_modules(DDE-Dock REQUIRED dde-dock)

file(GLOB TS_FILES "translations/*.ts")
qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(HotSpotlanguage ALL DEPENDS ${QM_FILES})

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS})

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

target_include_directories(${PLUGIN_NAME} PUBLIC
    ${NETWORKINTERFACE}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${DDE_DOCK_INCLUDE_DIR}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    ${NETINTERFACEINCLUDE}
    "../common-plugin"
    "../src"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${DDE-Network-Core_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/quick-trays)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)

=== dss_example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(dss_example)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(DdeControlCenter REQUIRED)
find_package(Qt6 COMPONENTS Core DBus Widgets Network REQUIRED)
find_package(KF6NetworkManagerQt REQUIRED)
find_package(Dtk6 COMPONENTS Widget REQUIRED)
find_package(DdeSessionShell REQUIRED)
find_package(PkgConfig REQUIRED)

aux_source_directory(../dss-network-plugin DSSPLUGINTHEMES)
aux_source_directory(../dss-network-plugin/notification DSSPLUGINNOTIFICATION)
aux_source_directory(../common-plugin COMMONPLUGINS)
aux_source_directory(../common-plugin/widgets COMMONPLUGINWIDGET)
aux_source_directory(../common-plugin/item COMMONPLUGINITEM)
aux_source_directory(. COMPILEFILES)

#set(COMPILEFILES ./*.h ./*.cpp)
file(GLOB_RECURSE COMMONPLUGINS_SRCS
    ../common-plugin/*
)
add_executable(${PROJECT_NAME}
    ${COMPILEFILES}
    ${NETWORKDIR}
    ${DSSPLUGINTHEMES}
    ${DSSPLUGINNOTIFICATION}
    ${COMMONPLUGINS_SRCS}
    ${REALIZEDIR})

target_include_directories(${PROJECT_NAME} PUBLIC
    ../dss-network-plugin
    ../common-plugin
    ../common-plugin/widgets
    ../common-plugin/item
    ../dss-network-plugin/interface
    ../src
    ${DdeControlCenter_INCLUDE_DIR}
    ${DDE_DOCK_INCLUDE_DIR}
    Dtk6::Widget
    Qt6::DBus
    Qt6::Network
    Qt6::Widgets
    KF6::NetworkManagerQt
    ${DDE-Network-Core_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${DdeControlCenter_LIBRARIES}
    ${DDE_DOCK_LIBRARIES}
    Dtk6::Widget
    Qt6::DBus
    Qt6::Network
    Qt6::Widgets
    KF6::NetworkManagerQt
    dde-network-core6
)

add_custom_command(
    OUTPUT path.pb.cc path.pb.h
    COMMAND protoc
    ARGS --cpp_out . ${CMAKE_CURRENT_SOURCE_DIR}/path.proto -I ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS path.proto)

=== network-service-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,12 @@
 endif()
 set(QT_NS 6)
 set(DTK_NS Dtk6)
+
+set(CMAKE_THREAD_LIBS_INIT "-lpthread")
+set(CMAKE_HAVE_THREADS_LIBRARY 1)
+set(CMAKE_USE_PTHREADS_INIT 1)
+set(CMAKE_PREFER_PTHREAD_FLAG ON)
+
 find_package(Qt${QT_NS} COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
 find_package(KF${QT_NS}NetworkManagerQt REQUIRED)
 find_package(${DTK_NS} COMPONENTS Core REQUIRED)

=== src-old/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})

file(GLOB_RECURSE SOURCEFILES "*.h" "*.cpp")
add_library(${PROJECT_NAME} SHARED ${SOURCEFILES})

find_package(Qt5 COMPONENTS Core DBus Network REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)

pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    realize
    ${KF5_QT_INCLUDE_DIRS}
    ${NETINTERFACEINCLUDE})

target_link_libraries(${PROJECT_NAME} PRIVATE
    Qt5::Core
    Qt5::DBus
    Qt5::Network
    PkgConfig::QGSettings
    ${KF5_QT_LIBRARIES})

set_target_properties(${PROJECT_NAME} PROPERTIES
  VERSION ${CMAKE_PROJECT_VERSION}
  SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
)

configure_file(dde-network-core.pc.in ../dde-network-core.pc @ONLY)

set(INTERFACEFILES
    dslcontroller.h
    hotspotcontroller.h
    networkconst.h
    networkcontroller.h
    networkdetails.h
    networkdevicebase.h
    proxycontroller.h
    vpncontroller.h
    wireddevice.h
    wirelessdevice.h)

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${CMAKE_BINARY_DIR}/dde-network-core.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(FILES ${INTERFACEFILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libddenetworkcore)
install(FILES ../config/org.deepin.dde.network.json DESTINATION ${CMAKE_INSTALL_DATADIR}/dsg/configs/org.deepin.dde.network)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(tst-dde-network)

set(CMAKE_THREAD_LIBS_INIT "-lpthread")
set(CMAKE_HAVE_THREADS_LIBRARY 1)
set(CMAKE_USE_PTHREADS_INIT 1)
set(CMAKE_PREFER_PTHREAD_FLAG ON)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt6 COMPONENTS Core Widgets DBus Network REQUIRED)
find_package(Dtk6 COMPONENTS Core REQUIRED)
find_package(GTest REQUIRED)
find_package(KF6NetworkManagerQt REQUIRED)
find_package(PkgConfig REQUIRED)

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions(-D SANITIZER_CHECK)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
endif()

aux_source_directory(. FILES)

add_executable(${PROJECT_NAME} ${FILES})

target_include_directories(${PROJECT_NAME} PUBLIC
    Qt6::Core
    Qt6::Network
    Dtk6::Core
    KF6::NetworkManagerQt
    ../src
    ../src/impl
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    Qt6::Core
    Qt6::Widgets
    Qt6::Network
    Dtk6::Core
    KF6::NetworkManagerQt
    ${GTEST_LIBRARIES}
    -lpthread
    -lm
    dde-network-core6
)

=== debian/changelog ===
dde-network-core (2.0.63) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#379)

 -- zhangkun <zhangkun2@uniontech.com>  Wed, 16 Jul 2025 10:28:05 +0800

dde-network-core (2.0.62) unstable; urgency=medium

  * fix: Compatible with installer plugin processingd3f2aed [dde-network-core] Updates for project Deepin Desktop Environment (#374)
  * fix: DSL connection deletion signal processing error
  * fix: Use the system default language when unable to retrieve users
  * chore: Update translation

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 10 Jul 2025 11:25:40 +0800

dde-network-core (2.0.61) unstable; urgency=medium

  * fix: fix safe build with debian/rules.
  * fix: SpinBox supports keyboard input
  * fix: Duplicate IP addresses do not prompt error messages
  * i18n: Updates for project Deepin Desktop Environment (#362)

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 3 Jul 2025 16:55:40 +0800

=== debian/control ===
Source: dde-network-core
Section: libs
Priority: optional
Maintainer: donghualin <donghualin@uniontech.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libglib2.0-dev (>= 2.32),
               pkg-config,
               libgtest-dev,
               dde-control-center-dev,
               dde-tray-loader-dev,
               dde-session-shell-dev,
               libudev-dev,               
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               libdtk6core-dev,
               libdtk6widget-dev,
               libkf6networkmanagerqt-dev
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://gerrit.uniontech.com/admin/repos/dde-network-core
Vcs-Browser: https://gerrit.uniontech.com/admin/repos/dde-network-core

Package: libdde-network-core
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},deepin-service-plugin-network
Description: the library of network
 libdde-network-core module

Package: libdde-network-core-dev
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
Description: the interface of networkcode,used for developers
 libdde-network-core-dev module

Package: dcc-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},network-manager-integration-plugins,libdde-network-core (= ${binary:Version})
Description: the plugin of network for dde control center
 dcc-network-plugin module

Package: dock-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
Description: the plugin of network for dde-dock
 dock-plugin module

Package: dss-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
Description: the plugin of network for dde-lock
 dss-network-plugin module

Package: deepin-service-plugin-network
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},curl
Description: the plugin of network service for deepin-service-manager
 deepin-service-plugin-network module

## dde-network-core 2.0.66

=== debian/changelog ===
dde-network-core (2.0.66) unstable; urgency=medium

  * fix: improve icon rendering with theme support
  * chore: remove some translation markers for proper nouns

 -- wujiangyu <wujiangyu@uniontech.com>  Thu, 14 Aug 2025 17:38:46 +0800

dde-network-core (2.0.65) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#389)
  * fix: Delete manually set IP address in IPv4 automatic mode
  * chore: add wifi7 dci icon

 -- wujiangyu <wujiangyu@uniontech.com>  Tue, 12 Aug 2025 10:39:43 +0800

dde-network-core (2.0.64) unstable; urgency=medium

  * Release 2.0.64

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 31 Jul 2025 19:44:25 +0800
